// Character.cpp: implementation of the Character class.
//
//////////////////////////////////////////////////////////////////////

#include "Character.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Character::Character()
{
	character = ' ';
}

Character::Character(const Character &right)
{
	character = right.character;
}

Character::~Character()
{
}

const Character &Character::operator=(const Character &right)
{
	if (this != &right) {
		character = right.character;
	}
	return *this;
}

int Character::operator==(const Character &right) const
{
	if (character == right.character)
		return 1;
	else
		return 0;
}

int Character::operator!=(const Character &right) const
{
	if (character != right.character)
		return 1;
	else
		return 0;
}

char Character::getCharacter() const
{
	return character;
}

void Character::setCharacter(const char c)
{
	character = c;
}

eCharacterType Character::getCharacterType() const
{
	eCharacterType answer = OTHER;

	if (character==0x20 || character==0x0D || character==0x0A  
	  || character==0x09)
		answer = WHITE_SPACE;
	else if (character>=0x21 && character<=0x7E)
		answer = TEXT;

	return answer;
}

void Character::print() const
{
	if (character==0x20)
		cout<<"SPC";
	else if (character==0x0D)
		cout<<"CR";
	else if (character==0x0A)
		cout<<"LF";
	else if (character==0x09)
		cout<<"TAB";
	else 
		cout<<character;
}

