// DecoratedChar.cpp: implementation of the DecoratedChar class.
//
//////////////////////////////////////////////////////////////////////

#include "DecoratedChar.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

DecoratedChar::DecoratedChar()
{
}

DecoratedChar::DecoratedChar(const DecoratedChar &right)
{
	character = right.character;
	decoration = right.decoration;
}

DecoratedChar::~DecoratedChar()
{
}

const DecoratedChar &DecoratedChar::operator=(const DecoratedChar &right)
{
	if (this != &right) {
		character = right.character;
		decoration = right.decoration;
	}
	return *this;
}

int DecoratedChar::operator==(const DecoratedChar &right) const
{
	if (character==right.character && decoration==right.decoration)
		return 1;
	else
		return 0;
}

int DecoratedChar::operator!=(const DecoratedChar &right) const
{
	if (character!=right.character || decoration!=right.decoration)
		return 1;
	else
		return 0;
}

const Character &DecoratedChar::getCharacter() const
{
	return character;
}

const PropertyRecord &DecoratedChar::getDecoration() const
{
	return decoration;
}

void DecoratedChar::setCharacter(const Character &c)
{
	character = c;
	if (character.getCharacterType() == WHITE_SPACE) {
		decoration.s = false;
		decoration.em = false;
		decoration.i = false;
		decoration.b = false;
		if (decoration.u == 0)
			decoration.color = 7;
	}
	if (decoration.u>MAX_UNDERLINE)
		decoration.u = MAX_UNDERLINE;
}

void DecoratedChar::setDecoration(const PropertyRecord &d)
{
	decoration = d;
	if (decoration.u>MAX_UNDERLINE)
		decoration.u = MAX_UNDERLINE;
}

void DecoratedChar::print() const
{
	character.print();
	cout<<"   ";
	decoration.print();
}
