#ifndef INTERPRETER_H
#define INTERPRETER_H

#include <iostream>
#include <vector>
#include "Document.h"
#include "DecoratedChar.h"
#include "PropertyRecord.h"
#include "TagTable.h"
using namespace std;

class Interpreter  
{
public:
	Interpreter();
	Interpreter(const Interpreter &);
	virtual ~Interpreter();

	const Interpreter &operator=(const Interpreter &);

	Document *getInput() const;
	vector<DecoratedChar> *getOutput() const;
	void setInput(Document *);
	void setOutput(vector<DecoratedChar> *);

	void setup();
	void run();
	void print() const;
private:
	Document *input;
	vector<DecoratedChar> *output;

	TagTable tag_table;
	vector<PropertyRecord> prstack;
};

#endif
