#ifndef OPTIMIZER_H
#define OPTIMIZER_H

#include <iostream>
#include <string>
#include <vector>
#include "Document.h"
#include "DecoratedChar.h"
#include "PropertyRecord.h"
#include "TagTable.h"
#include "Move.h"
using namespace std;

class Optimizer  
{
public:
	Optimizer();
	Optimizer(const Optimizer &);
	virtual ~Optimizer();

	const Optimizer &operator=(const Optimizer &);

	vector<DecoratedChar> *getInput() const;
	void setInput(vector<DecoratedChar> *);

	void setup();
	void run();
	void print() const;
	void printResult(Document *) const;
private:
	vector<DecoratedChar> *input;
	TagTable tag_table;
	vector<PropertyRecord> prstack;
	vector<int> state_change_table;
	vector<Move> best_move_table;
	Move last_best_move;
	
	void makeStateChangeTable();
	int search(const int,int);
	void findMoves(const int,vector<Move> &);
	int scoreMove(const Move &);
};

#endif
