// PropertyRecord.cpp: implementation of the PropertyRecord class.
//
//////////////////////////////////////////////////////////////////////

#include "PropertyRecord.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PropertyRecord::PropertyRecord()
{
	b = em = i = s = tt = false;
	u = 0;
	size = ANY_SIZE;
	color = ANY_COLOR;
}

PropertyRecord::PropertyRecord(const PropertyRecord &right)
{
	b = right.b;
	em = right.em;
	i = right.i;
	s = right.s;
	tt = right.tt;
	u = right.u;
	size = right.size;
	color = right.color;
}

PropertyRecord::~PropertyRecord()
{
}

const PropertyRecord &PropertyRecord::operator=(const PropertyRecord &right)
{
	if (this != &right) {
		b = right.b;
		em = right.em;
		i = right.i;
		s = right.s;
		tt = right.tt;
		u = right.u;
		size = right.size;
		color = right.color;
	}
	return *this;
}

int PropertyRecord::operator==(const PropertyRecord &right) const
{
	if (b==right.b && em==right.em && i==right.i && s==right.s 
	  && tt==right.tt && u==right.u && size == right.size 
	  && color==right.color)
		return 1;
	else
		return 0;
}

int PropertyRecord::operator!=(const PropertyRecord &right) const
{
	if (b==right.b && em==right.em && i==right.i && s==right.s 
	  && tt==right.tt && u==right.u && size == right.size 
	  && color==right.color)
		return 0;
	else
		return 1;
}

void PropertyRecord::applyTag(const int tag)
{
	if (tag == 0)
		b = true;
	else if (tag == 1) {
		if (s == false) 
			if (em == true)
				em = false;
			else
				em = true;
	}
	else if (tag == 2) { 
		i = true;
	}
	else if (tag == 3) {
		s = false;
		em = false;
		i = false;
		b = false;
		tt = false;
		u = 0;
	}
	else if (tag == 4) {
		s = true;
		em = false;
	}
	else if (tag == 5)
		tt = true;
	else if (tag == 6)
		u++;
	else if (tag <= 16)
		size = tag - 7;
	else if (tag <= 24)
		color = tag - 17;
}

void PropertyRecord::setup()
{
	b = em = i = s = tt = false;
	u = 0;
	size = ANY_SIZE;
	color = ANY_COLOR;
}

void PropertyRecord::print() const
{
	cout << "b("<<b<<") ";
	cout << "em("<<em<<") ";
	cout << "i("<<i<<") ";
	cout << "s("<<s<<") ";
	cout << "tt("<<tt<<") ";
	cout << "u("<<u<<") ";
	cout << "size("<<size<<") ";
	cout << "color("<<color<<") ";
	cout << endl;
}
