#include "Clock.h"
#include "Document.h"
#include "DecoratedChar.h"
#include "Interpreter.h"
#include "Optimizer.h"

int main(int argc, char* argv[])
{
	Clock timer;
	double time_limit;
	Document *doc;
	vector<DecoratedChar> *output;
	Interpreter interpreter;
	Optimizer optimizer;

	timer.setStartTime();
	time_limit = 0;
	if (argc > 1)
		time_limit = atof(argv[1]);
	if (time_limit<180)
		time_limit = 180;

	doc = new Document;
	doc->load();
	output = new vector<DecoratedChar>;

	interpreter.setInput(doc);
	interpreter.setOutput(output);
	interpreter.run();
	
	optimizer.setInput(interpreter.getOutput());	
	optimizer.run();
	optimizer.printResult(doc);
	
	return 0;
}