// Stack.cpp: implementation of the Stack class.
//
//////////////////////////////////////////////////////////////////////

#include "Stack.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Stack::Stack()
{
	stack.push_back(-1);
}

Stack::Stack(const Stack &right)
{
	stack = right.stack;
}

Stack::~Stack()
{
}

const Stack &Stack::operator=(const Stack &right)
{
	if (this != &right) {
		stack = right.stack;
	}
	return *this;
}

void Stack::push(const int value)
{
	stack.push_back(value);
}

int Stack::pop()
{
	int answer;
	
	answer = stack.back();
	stack.pop_back();
	
	return answer;
}

int Stack::last() const
{
	return stack.back();
}

int Stack::last (const int max) const
{
	vector<int>::size_type i;
	int answer;

	i=stack.size()-1;
	while (stack[i]>=max && i>0)
		i--;
	answer = stack[i];

	return answer;
}

int Stack::size() const
{
	return stack.size()-1;
}

int Stack::sizeGreater(const int value) const
{
	int answer = 0;
	vector<int>::size_type i;
	
	for (i=1;i<stack.size();i++)
		if (stack[i] > value)
			answer++;

	return answer;
}

void Stack::print() const
{
	vector<int>::size_type i;

	for (i=0;i<stack.size();i++) 
		cout<<stack[i]<<",";
}
