// TagTable.cpp: implementation of the TagTable class.
//
//////////////////////////////////////////////////////////////////////

#include "TagTable.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TagTable::TagTable()
{
	Tag tag1;
	char *commandStr[25] = {"B","EM","I","PL","S","TT","U",
	"0","1","2","3","4","5","6","7","8","9",
	"r","g","b","c","m","y","k","w"};
	string temp;
	for (int i=0;i<25;i++) {
		temp = commandStr[i];
		tag1.setName(temp);
		table.push_back(tag1);
	}
}

TagTable::TagTable(const TagTable &right)
{
	table = right.table;
}

TagTable::~TagTable()
{
}

const TagTable &TagTable::operator=(const TagTable &right)
{
	if (this != &right) {
		table = right.table;
	}
	return * this;
}

const vector<Tag> &TagTable::getTable() const
{
	return table;
}

void TagTable::setTable(const vector<Tag> &vt)
{
	table = vt;
}

int TagTable::findTag(const string &str) const
{
	int answer = -1;
	vector<Tag>::size_type i;

	for (i=0;i<table.size();i++) {
		if (str == table[i].getName()) {
			answer = i;
			break;
		}
	}

	return answer;
}

void TagTable::print() const
{
	vector<Tag>::size_type i;

	for (i=0;i<table.size();i++) {
		cout<<"Tag "<<i<<":";
		table[i].print();
		cout<<endl;
	}
}